Index: tmp/org.txm.core/src/java/org/txm/StandaloneTest.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/StandaloneTest.java	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/StandaloneTest.java	(revision 313)
@@ -0,0 +1,53 @@
+package org.txm;
+
+import java.util.ServiceLoader;
+
+import org.eclipse.core.internal.runtime.Activator;
+import org.eclipse.core.internal.runtime.InternalPlatform;
+import org.osgi.framework.BundleContext;
+import org.osgi.framework.Filter;
+import org.osgi.framework.launch.Framework;
+import org.osgi.framework.launch.FrameworkFactory;
+import org.osgi.util.tracker.ServiceTracker;
+import org.txm.core.preferences.TBXPreferences;
+
+public class StandaloneTest {
+	
+	public static void main(String[] args) {
+		
+		try {
+			
+			//Load the framwork factory
+	        ServiceLoader loader = ServiceLoader.load( FrameworkFactory.class );
+	        System.out.println("ServiceLoader= "+loader);
+	        
+	        FrameworkFactory factory = ( FrameworkFactory ) loader.iterator( ).next( );
+	        System.out.println("FrameworkFactory= "+loader);
+	        
+	        // Create a new instance of the framework
+	        Framework framework = factory.newFramework( null );
+	        System.out.println("Framework="+framework);
+	        framework.init( );
+	        framework.start( );
+	        
+	        BundleContext bc = framework.getBundleContext();
+	        System.out.println("BundleContext: "+bc);
+	        
+	        Filter filter = bc.createFilter("(objectClass=*ServiceTasks)");
+	        System.out.println("Filter: "+filter);
+	        
+	        ServiceTracker serviceTaskTracker = new ServiceTracker(bc, filter, null);
+	        System.out.println("ServiceTracker: "+serviceTaskTracker);
+	        
+	        InternalPlatform.getDefault().start(bc);
+	        System.out.println("context started");
+	        
+	     //   Activator.getDefault().start(bc); 
+			
+			Toolbox.initialize(TBXPreferences.class);
+		} catch (Exception e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+}

Index: tmp/org.txm.core/src/java/org/txm/functions/summary/Summary.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/functions/summary/Summary.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/functions/summary/Summary.java	(revision 313)
@@ -2,6 +2,7 @@
 
 import java.io.IOException;
 import java.util.ArrayList;
+import java.util.Arrays;
 
 import org.txm.Toolbox;
 import org.txm.core.messages.TXMCoreMessages;
@@ -17,8 +18,6 @@
 import org.txm.searchengine.cqp.corpus.query.Query;
 import org.txm.searchengine.cqp.serverException.CqiServerError;
 
-import cern.colt.Arrays;
-
 public class Summary extends TXMResult  {
 	MainCorpus corpus;
 	TreeNode treenodes = new TreeNode("root"); //$NON-NLS-1$
Index: tmp/org.txm.core/src/java/org/txm/annotation/conversion/CorpusRuledConvertion.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/annotation/conversion/CorpusRuledConvertion.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/annotation/conversion/CorpusRuledConvertion.java	(revision 313)
@@ -7,8 +7,11 @@
 import java.util.LinkedHashMap;
 import java.util.regex.Pattern;
 
+import javax.xml.stream.XMLStreamException;
+
 import org.apache.commons.lang.StringUtils;
 import org.txm.Toolbox;
+import org.txm.core.preferences.TBXPreferences;
 import org.txm.searchengine.cqp.corpus.MainCorpus;
 import org.txm.stat.utils.ConsoleProgressBar;
 import org.txm.utils.io.IOUtils;
@@ -46,7 +49,7 @@
 		this.rules = rules;
 	}
 
-	public boolean process(MainCorpus corpus) {
+	public boolean process(MainCorpus corpus) throws XMLStreamException, IOException {
 		File binaryCorpusDirectory = corpus.getBaseDirectory();
 		File txmDirectory = new File(binaryCorpusDirectory, "txm");
 		if (!txmDirectory.exists()) {
@@ -91,7 +94,7 @@
 					}
 					if (errors.size() > 10) {
 						try {
-							File errorFile = new File(Toolbox.getParam(Toolbox.USER_TXM_HOME), "errors.txt");
+							File errorFile = new File(Toolbox.getParam(TBXPreferences.USER_TXM_HOME), "errors.txt");
 							IOUtils.write(errorFile, StringUtils.join(errors, "\t"));
 							System.out.println("More errors, see "+errorFile.getAbsolutePath());
 						} catch (Exception e) {
Index: tmp/org.txm.core/src/java/org/txm/annotation/conversion/XMLTXMFileRuledConversion.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/annotation/conversion/XMLTXMFileRuledConversion.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/annotation/conversion/XMLTXMFileRuledConversion.java	(revision 313)
@@ -1,6 +1,7 @@
 package org.txm.annotation.conversion;
 
 import java.io.File;
+import java.io.IOException;
 import java.util.HashSet;
 import java.util.LinkedHashMap;
 import java.util.regex.Pattern;
@@ -20,7 +21,7 @@
 	public static final String ABANDON = "abandon";
 	HashSet<String> noMatchValues = new HashSet<String>();
 	
-	public XMLTXMFileRuledConversion(File infile, LinkedHashMap<Pattern, String> rules, String oldType, String newType, String mode) {
+	public XMLTXMFileRuledConversion(File infile, LinkedHashMap<Pattern, String> rules, String oldType, String newType, String mode) throws IOException, XMLStreamException {
 		super(infile);
 		this.rules = rules;
 		this.oldType = oldType;
@@ -41,7 +42,7 @@
 	private Object mode;
 
 	@Override
-	public void processStartElement() {
+	public void processStartElement() throws XMLStreamException, IOException {
 		if (!inW) super.processStartElement(); // don't write W content
 
 		if (localname.equals("w")) {
@@ -66,14 +67,14 @@
 	}
 
 	@Override
-	public void processCharacters() {
+	public void processCharacters() throws XMLStreamException {
 		if (inW && inAna) typeValue+=parser.getText();
 		else if (inW && inForm) formValue+=parser.getText();
 		else super.processCharacters();
 	}
 
 	@Override
-	public void processEndElement() {
+	public void processEndElement() throws XMLStreamException {
 		if (localname.equals("w")) {
 			inW = false;
 
@@ -154,6 +155,7 @@
 	}
 
 	public static void main(String args[]) {
+		try {
 		File xmlFile = new File("/home/mdecorde/TXM/corpora/XTZTEXTUALPLANS/txm/XTZTEXTUALPLANS/test.xml");
 		File tmpFile = new File("/home/mdecorde/TXM/corpora/XTZTEXTUALPLANS/txm/XTZTEXTUALPLANS/test-o.xml");
 		String oldType = "type";
@@ -165,5 +167,8 @@
 		rules.put(Pattern.compile("y.*"), "YMULTIWORD");
 		XMLTXMFileRuledConversion converter = new XMLTXMFileRuledConversion(xmlFile, rules, oldType, newType, ABANDON);
 		System.out.println(converter.process(tmpFile));
+		} catch (Exception e) {
+			e.printStackTrace();
+		}
 	}
 }
Index: tmp/org.txm.core/src/java/org/txm/annotation/AnnotationWriter.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/annotation/AnnotationWriter.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/annotation/AnnotationWriter.java	(revision 313)
@@ -11,11 +11,14 @@
 import java.util.List;
 import java.util.logging.Level;
 
+import javax.xml.stream.XMLStreamException;
+
 import org.apache.commons.lang.StringUtils;
 import org.txm.Toolbox;
 import org.txm.annotation.repository.AnnotationEffect;
 import org.txm.annotation.repository.AnnotationType;
 import org.txm.annotation.repository.KnowledgeRepository;
+import org.txm.core.preferences.TBXPreferences;
 import org.txm.importer.ValidateXml;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.clientExceptions.InvalidCqpIdException;
@@ -54,8 +57,9 @@
 	 * @throws CqiServerError
 	 * @throws CqiClientException
 	 * @throws InvalidCqpIdException
+	 * @throws XMLStreamException 
 	 */
-	protected boolean writeTextAnnotationToSyMoGIH(String textid, File currentXMLFile, File currentXMLStandoffFile, File xmlStandOffDirectory) throws IOException, CqiServerError, CqiClientException, InvalidCqpIdException{
+	protected boolean writeTextAnnotationToSyMoGIH(String textid, File currentXMLFile, File currentXMLStandoffFile, File xmlStandOffDirectory) throws IOException, CqiServerError, CqiClientException, InvalidCqpIdException, XMLStreamException{
 		System.out.println("  text="+textid);
 		boolean show_debug = Log.getLevel().intValue() < Level.WARNING.intValue();
 		
@@ -84,13 +88,14 @@
 	 * @throws CqiServerError
 	 * @throws CqiClientException
 	 * @throws InvalidCqpIdException
+	 * @throws XMLStreamException 
 	 */
-	public boolean writeAnnotationsInStandoff(File resultZipFile) throws IOException, CqiServerError, CqiClientException, InvalidCqpIdException{
+	public boolean writeAnnotationsInStandoff(File resultZipFile) throws IOException, CqiServerError, CqiClientException, InvalidCqpIdException, XMLStreamException{
 		
 		List<String> textsIds = corpus.getTextsID();
 		System.out.println("Exporting annotations of "+StringUtils.join(textsIds, ", ")+".");
 
-		File resultDirectory = new File(Toolbox.getParam(Toolbox.USER_TXM_HOME), "results/"+corpus.getName()+"_annotations");
+		File resultDirectory = new File(Toolbox.getParam(TBXPreferences.USER_TXM_HOME), "results/"+corpus.getName()+"_annotations");
 		DeleteDir.deleteDirectory(resultDirectory);
 		resultDirectory.mkdirs();
 		if (!(resultDirectory.exists() && resultDirectory.canWrite())) {
@@ -130,8 +135,9 @@
 	 * @throws CqiServerError
 	 * @throws CqiClientException
 	 * @throws InvalidCqpIdException
+	 * @throws XMLStreamException 
 	 */
-	public boolean writeAnnotations(List<Annotation> allCorpusAnnotations) throws IOException, CqiServerError, CqiClientException, InvalidCqpIdException{
+	public boolean writeAnnotations(List<Annotation> allCorpusAnnotations) throws IOException, CqiServerError, CqiClientException, InvalidCqpIdException, XMLStreamException{
 		//MainCorpus corpus = CorpusManager.getCorpusManager().getCorpus(c.getName());
 		System.out.println("Saving "+allCorpusAnnotations.size()+"annotations...");
 
@@ -229,7 +235,7 @@
 	//writeAnnotationInStandoffFile(currentXMLStandoffFile, allAnnotations, annotator, tmpXMLTXMDirectory, previousXMLTXMDirectory))
 	
 	protected boolean writeAnnotationsInFile(File xmlFile, int text_start_position, 
-			ArrayList<Annotation> segmentAnnotations, ArrayList<Annotation> tokenAnnotations, File tmpXMLTXMDirectory, File previousXMLTXMDirectory) throws CqiClientException, IOException, CqiServerError, InvalidCqpIdException{
+			ArrayList<Annotation> segmentAnnotations, ArrayList<Annotation> tokenAnnotations, File tmpXMLTXMDirectory, File previousXMLTXMDirectory) throws CqiClientException, IOException, CqiServerError, InvalidCqpIdException, XMLStreamException{
 		System.out.println("Writing annotations for text "+xmlFile+" segment annotations="+segmentAnnotations.size()+" token annotations="+tokenAnnotations.size());
 		System.out.println(segmentAnnotations);
 		System.out.println(tokenAnnotations);
Index: tmp/org.txm.core/src/java/org/txm/annotation/AnnotationInjector.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/annotation/AnnotationInjector.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/annotation/AnnotationInjector.java	(revision 313)
@@ -65,9 +65,10 @@
 	 * @param annotationsToAddByEndPos
 	 * @param corpus_start_position
 	 * @param debug
-	 * @throws MalformedURLException
+	 * @throws XMLStreamException 
+	 * @throws IOException 
 	 */
-	public AnnotationInjector(File xmlFile, List<Annotation> segmentAnnotations, ArrayList<Annotation> tokenAnnotations, int corpus_start_position, boolean debug) throws MalformedURLException {
+	public AnnotationInjector(File xmlFile, List<Annotation> segmentAnnotations, ArrayList<Annotation> tokenAnnotations, int corpus_start_position, boolean debug) throws IOException, XMLStreamException {
 		super(xmlFile.toURI().toURL()); // init reader and writer
 
 		this.user = System.getProperty("user.name");
@@ -140,7 +141,7 @@
 	boolean mustChangeAnaValue = false;
 	boolean inAna = false;
 
-	protected void processStartElement() {
+	protected void processStartElement() throws XMLStreamException, IOException {
 		
 		currentStartAnnotations = annotationsToAddByStartPos.get(position_counter);
 		currentEndAnnotations = annotationsToAddByEndPos.get(position_counter);
@@ -317,7 +318,7 @@
 	}
 
 	@Override
-	public void processCharacters() {
+	public void processCharacters() throws XMLStreamException {
 		//System.out.println("processCharaters inAna="+inAna+" mustChangeAnaValue="+mustChangeAnaValue);
 		if (inAna && mustChangeAnaValue) {
 			// nothing content is already written
@@ -327,7 +328,7 @@
 		}
 	}
 
-	protected void processEndElement() {
+	protected void processEndElement() throws XMLStreamException {
 		// currentEndAnnotations =
 		// annotationsToAddByEndPos.get(position_counter); // annotation to end
 		previousEndAnnotations = annotationsToAddByEndPos.get(position_counter - 1); // existing
@@ -613,7 +614,7 @@
 	static int UPDATEDELETEADD6 = 17;
 	static int ADDDELETE2 = 18;
 
-	public static void main2(String args[]) throws IOException {
+	public static void main2(String args[]) throws IOException, XMLStreamException {
 		File xmlFile = null;
 		int corpus_start_position = 10;
 
@@ -728,6 +729,7 @@
 	}
 
 	public static void main(String[] args) {
+		try {
 		File xmlFile = new File("/home/mdecorde/TXM/corpora/TDM80J/txm/TDM80J/tdm80j.xml");
 		File outfile = new File("/home/mdecorde/TXM/corpora/TDM80J/txm/TDM80J/tdm80j-annot.xml");
 
@@ -743,12 +745,12 @@
 		for (int p : positions) tokenAnnotations.add(new Annotation("frlemma", "de", p, p+5));
 		
 		AnnotationInjector ai;
-		try {
+		
 			ai = new AnnotationInjector(xmlFile, segmentAnnotations, tokenAnnotations, 0, true);
 			System.out.println("start processing...");
 			ai.process(outfile);
 			System.out.println("Done.");
-		} catch (MalformedURLException e) {
+		} catch (Exception e) {
 			e.printStackTrace();
 		}
 	}
Index: tmp/org.txm.core/src/java/org/txm/annotation/repository/KnowledgeRepositoryManager.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/annotation/repository/KnowledgeRepositoryManager.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/annotation/repository/KnowledgeRepositoryManager.java	(revision 313)
@@ -7,6 +7,7 @@
 import org.apache.commons.io.FileUtils;
 import org.txm.Toolbox;
 import org.txm.annotation.DatabasePersistenceManager;
+import org.txm.core.preferences.TBXPreferences;
 import org.txm.objects.BaseParameters;
 import org.txm.sql.SQLConnection;
 import org.txm.utils.logger.Log;
@@ -98,7 +99,7 @@
 	
 	public static KnowledgeRepository getKnowledgeRepository(String name) {
 		KnowledgeRepository kr = null;
-		File krconf = new File(Toolbox.getParam(Toolbox.USER_TXM_HOME),"repositories/"+name+"/conf.xml");
+		File krconf = new File(Toolbox.getParam(TBXPreferences.USER_TXM_HOME),"repositories/"+name+"/conf.xml");
 		if (repositories.containsKey(name)) {
 			kr = repositories.get(name);
 		} else {
@@ -123,7 +124,7 @@
 	 */
 	public static KnowledgeRepository getKnowledgeRepository(String name, org.txm.objects.Corpus corpus) {
 		KnowledgeRepository kr = null;
-		File krconf = new File(Toolbox.getParam(Toolbox.USER_TXM_HOME),"repositories/"+name+"/conf.xml");
+		File krconf = new File(Toolbox.getParam(TBXPreferences.USER_TXM_HOME),"repositories/"+name+"/conf.xml");
 		if (repositories.containsKey(name)) {
 			kr = repositories.get(name);
 		} else {
@@ -214,7 +215,7 @@
 	public static String generateLocalURLPage(String krname, String name, String id) {
 	
 		KnowledgeRepository kr = getKnowledgeRepository(krname);
-		String path = Toolbox.getParam(Toolbox.USER_TXM_HOME)+"/repositories/"+krname;
+		String path = Toolbox.getParam(TBXPreferences.USER_TXM_HOME)+"/repositories/"+krname;
 		//File htmlTemplateFile = new File(path+"/template.html");
 		File newHtmlFile = null;
 		String htmlString;
Index: tmp/org.txm.core/src/java/org/txm/annotation/repository/LocalKnowledgeRepository.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/annotation/repository/LocalKnowledgeRepository.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/annotation/repository/LocalKnowledgeRepository.java	(revision 313)
@@ -7,6 +7,7 @@
 
 import org.txm.Toolbox;
 import org.txm.annotation.DatabasePersistenceManager;
+import org.txm.core.preferences.TBXPreferences;
 import org.txm.sql.SQLConnection;
 
 public class LocalKnowledgeRepository extends KnowledgeRepository {
@@ -26,7 +27,7 @@
 
 		String path = accessProperties.get(SQLConnection.SQL_ADDRESS);
 		if (path == null || path.trim().length() == 0) { // no address, forge one 
-			path = Toolbox.getParam(Toolbox.USER_TXM_HOME)+"/repositories/"+getName();
+			path = Toolbox.getParam(TBXPreferences.USER_TXM_HOME)+"/repositories/"+getName();
 			System.out.println("No address given to build values. No values created");
 			return true;
 		}
Index: tmp/org.txm.core/src/java/org/txm/annotation/repository/KnowledgeRepository.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/annotation/repository/KnowledgeRepository.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/annotation/repository/KnowledgeRepository.java	(revision 313)
@@ -13,6 +13,7 @@
 import org.eclipse.persistence.jpa.PersistenceProvider;
 import org.txm.Toolbox;
 import org.txm.annotation.DatabasePersistenceManager;
+import org.txm.core.preferences.TBXPreferences;
 import org.txm.utils.logger.Log;
 
 public abstract class KnowledgeRepository  { //extends Vector<AnnotationType>
@@ -62,7 +63,7 @@
 	 * @return
 	 */
 	public EntityManager initializeEntityManager(){
-		this.dbPath = Toolbox.getParam(Toolbox.USER_TXM_HOME)+"/repositories/"+name;
+		this.dbPath = Toolbox.getParam(TBXPreferences.USER_TXM_HOME)+"/repositories/"+name;
 		//System.out.println("KnowledgeRepository.initializeEntityManager [DB @ "+dbPath+"]");
 		EntityManagerFactory emf;
 		HashMap<String, Object> properties = new HashMap<String, Object>();
Index: tmp/org.txm.core/src/java/org/txm/annotation/PropertiesRecoder.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/annotation/PropertiesRecoder.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/txm/annotation/PropertiesRecoder.java	(revision 313)
@@ -1,6 +1,7 @@
 package org.txm.annotation;
 
 import java.io.File;
+import java.io.IOException;
 import java.util.ArrayList;
 import java.util.HashSet;
 import java.util.LinkedHashMap;
@@ -10,8 +11,8 @@
 import org.txm.importer.StaxIdentityParser;
 
 public class PropertiesRecoder extends StaxIdentityParser {
-	
-	public PropertiesRecoder(File xmlFile, HashSet<String> fromProperties, HashSet<String> toProperties) {
+
+	public PropertiesRecoder(File xmlFile, HashSet<String> fromProperties, HashSet<String> toProperties) throws IOException, XMLStreamException {
 		super(xmlFile);
 	}
 	boolean startW = false, startAna = false;
@@ -19,9 +20,9 @@
 	String[] currentAnaValues = {"","",""};
 	StringBuilder anaValue = new StringBuilder();
 	String EMPTY = "";
-	
+
 	@Override
-	public void processStartElement() {
+	public void processStartElement() throws XMLStreamException, IOException {
 		if (localname.equals("w")) {
 			startW = true;
 			anaValues.clear();
@@ -45,21 +46,21 @@
 			super.processStartElement();
 		}
 	}
-	
+
 	@Override
-	public void processCharacters() {
+	public void processCharacters() throws XMLStreamException {
 		if (startAna) {
 			anaValue.append(parser.getText());
 		} else {
 			super.processCharacters();
 		}
 	};
-	
+
 	@Override
-	public void processEndElement() {
+	public void processEndElement() throws XMLStreamException {
 		if (localname.equals("w")) {
 			startW = false;
-			
+
 			for (String[] values : anaValues) {
 				try {
 					writer.writeStartElement("txm:ana");
@@ -72,7 +73,7 @@
 					e.printStackTrace();
 				}
 			}
-			
+
 			super.processEndElement();
 		} else if (localname.equals("ana")) {
 			if (startW) {
@@ -84,14 +85,18 @@
 			super.processEndElement();
 		}
 	}
-	
+
 	public static void main(String args[]) {
-		File xmlFile = new File("/home/mdecorde/TEMP/test.xml");
-		File outfile = new File("/home/mdecorde/TEMP/test-o.xml");
-		HashSet<String> fromProperties = new HashSet<String>();
-		HashSet<String> toProperties = new HashSet<String>();
-		
-		PropertiesRecoder recoder = new PropertiesRecoder(xmlFile, fromProperties, toProperties);
-		System.out.println("Result: "+recoder.process(outfile));
+		try {
+			File xmlFile = new File("/home/mdecorde/TEMP/test.xml");
+			File outfile = new File("/home/mdecorde/TEMP/test-o.xml");
+			HashSet<String> fromProperties = new HashSet<String>();
+			HashSet<String> toProperties = new HashSet<String>();
+
+			PropertiesRecoder recoder = new PropertiesRecoder(xmlFile, fromProperties, toProperties);
+			System.out.println("Result: "+recoder.process(outfile));
+		} catch(Exception e) {
+			e.printStackTrace();
+		}
 	}
 }
Index: tmp/org.txm.core/src/java/org/txm/MemEngine.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/MemEngine.java	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/MemEngine.java	(revision 313)
@@ -0,0 +1,25 @@
+package org.txm;
+
+/**
+ * Abstract class of an Engine that does not needs third application/server to work (eg. CQPlib)
+ * 
+ * @author mdecorde
+ *
+ */
+public abstract class MemEngine extends Engine {
+
+	@Override
+	public boolean isDistant() {
+		return false;
+	}
+
+	@Override
+	public boolean connect() {
+		return true;
+	}
+
+	@Override
+	public boolean disconnect() {
+		return false;
+	}
+}

Index: tmp/org.txm.core/src/java/org/txm/Engine.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/Engine.java	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/Engine.java	(revision 313)
@@ -0,0 +1,83 @@
+package org.txm;
+
+/**
+ * Extension point for an Engine. It is a service that may be used by TXM commands
+ * 
+ * The Toolbox manages the services life-cycle 
+ * 
+ * @author mdecorde
+ *
+ */
+public abstract class Engine {
+	
+	public static final String ENGINE_EXTENSION_POINT_ID = "org.txm.engine";
+	
+	/**
+	 * if the method returns false then the Toolbox is not initialized
+	 * 
+	 * @return 
+	 */
+	public abstract boolean isMandatory(); // for now the Toolbox has no mandatory engine request
+	
+	/**
+	 * if the method returns false, the TBX does not need to call start and stop methods
+	 * @return
+	 */
+	public abstract boolean isDistant();
+	
+	/**
+	 * called to now if the Engine may be used
+	 * 
+	 * @return
+	 */
+	public abstract boolean isReady();
+	
+	/**
+	 * Initialize the Engine, optional if the Engine is distant
+	 * @return
+	 */
+	public abstract boolean start();
+	
+	/**
+	 * Called to start a session in the Engine
+	 * @return
+	 */
+	public abstract boolean connect();
+	
+	/**
+	 * Called to end a session in the Engine
+	 * @return
+	 */
+	public abstract boolean disconnect();
+	
+	/**
+	 * Close the Engine, optional if the Engine is distant
+	 * @return
+	 */
+	public abstract boolean stop();
+	
+	/**
+	 * Shortcut method to restart an Engine
+	 * 
+	 * @return
+	 */
+	public boolean restart() {
+		return disconnect() && stop() && start();
+	}
+	
+	/**
+	 * Shortcut to restart a session with the Engine
+	 * @return
+	 */
+	public boolean reconnect() {
+		return disconnect() && connect();
+	}
+	
+	/**
+	 * Shortcut to restart and reconnect to an engine
+	 * @return
+	 */
+	public boolean restartAndReconnect() {
+		return disconnect() && stop() && start() && connect();
+	}
+}

Index: tmp/org.txm.core/src/java/org/kohsuke/args4j/spi/MultiValueFieldSetter.java
===================================================================
--- tmp/org.txm.core/src/java/org/kohsuke/args4j/spi/MultiValueFieldSetter.java	(revision 312)
+++ tmp/org.txm.core/src/java/org/kohsuke/args4j/spi/MultiValueFieldSetter.java	(revision 313)
@@ -58,11 +58,11 @@
 
     private void doAddValue(Object bean, Object value) throws IllegalAccessException {
         Object o = f.get(bean);
-        if(o==null) {
-            o = new ArrayList();
+        if (o==null) {
+            o = new ArrayList<Object>();
             f.set(bean,o);
         }
-        if(!(o instanceof List))
+        if (!(o instanceof List))
             throw new IllegalAnnotationError(Messages.ILLEGAL_LIST.format(f));
 
         ((List)o).add(value);
Index: tmp/org.txm.core/schema/engine.exsd
===================================================================
--- tmp/org.txm.core/schema/engine.exsd	(revision 0)
+++ tmp/org.txm.core/schema/engine.exsd	(revision 313)
@@ -0,0 +1,119 @@
+<?xml version='1.0' encoding='UTF-8'?>
+<!-- Schema file written by PDE -->
+<schema targetNamespace="org.txm.core" xmlns="http://www.w3.org/2001/XMLSchema">
+<annotation>
+      <appinfo>
+         <meta.schema plugin="org.txm.core" id="org.txm.engine" name="Engine"/>
+      </appinfo>
+      <documentation>
+         A service with a start, connect, disconnect and stop lifecycle
+      </documentation>
+   </annotation>
+
+   <element name="extension">
+      <annotation>
+         <appinfo>
+            <meta.element />
+         </appinfo>
+      </annotation>
+      <complexType>
+         <choice minOccurs="1" maxOccurs="unbounded">
+            <element ref="Engine"/>
+         </choice>
+         <attribute name="point" type="string" use="required">
+            <annotation>
+               <documentation>
+                  
+               </documentation>
+            </annotation>
+         </attribute>
+         <attribute name="id" type="string">
+            <annotation>
+               <documentation>
+                  
+               </documentation>
+            </annotation>
+         </attribute>
+         <attribute name="name" type="string">
+            <annotation>
+               <documentation>
+                  
+               </documentation>
+               <appinfo>
+                  <meta.attribute translatable="true"/>
+               </appinfo>
+            </annotation>
+         </attribute>
+      </complexType>
+   </element>
+
+   <element name="Engine">
+      <complexType>
+         <attribute name="class" type="string">
+            <annotation>
+               <documentation>
+                  
+               </documentation>
+               <appinfo>
+                  <meta.attribute kind="java" basedOn="org.txm.Engine:"/>
+               </appinfo>
+            </annotation>
+         </attribute>
+         <attribute name="name" type="string" use="required">
+            <annotation>
+               <documentation>
+                  
+               </documentation>
+            </annotation>
+         </attribute>
+         <attribute name="description" type="string" use="required">
+            <annotation>
+               <documentation>
+                  
+               </documentation>
+               <appinfo>
+                  <meta.attribute translatable="true"/>
+               </appinfo>
+            </annotation>
+         </attribute>
+      </complexType>
+   </element>
+
+   <annotation>
+      <appinfo>
+         <meta.section type="since"/>
+      </appinfo>
+      <documentation>
+         [Enter the first release in which this extension point appears.]
+      </documentation>
+   </annotation>
+
+   <annotation>
+      <appinfo>
+         <meta.section type="examples"/>
+      </appinfo>
+      <documentation>
+         [Enter extension point usage example here.]
+      </documentation>
+   </annotation>
+
+   <annotation>
+      <appinfo>
+         <meta.section type="apiinfo"/>
+      </appinfo>
+      <documentation>
+         [Enter API information here.]
+      </documentation>
+   </annotation>
+
+   <annotation>
+      <appinfo>
+         <meta.section type="implementation"/>
+      </appinfo>
+      <documentation>
+         [Enter information about supplied implementation of this extension point.]
+      </documentation>
+   </annotation>
+
+
+</schema>

Index: tmp/org.txm.core/.classpath
===================================================================
--- tmp/org.txm.core/.classpath	(revision 312)
+++ tmp/org.txm.core/.classpath	(revision 313)
@@ -38,7 +38,6 @@
 	<classpathentry kind="src" path="src/java"/>
 	<classpathentry kind="src" path="test"/>
 	<classpathentry exported="true" kind="lib" path="bin/" sourcepath="src/java"/>
-	<classpathentry excluding="org/txm/importer/graal/xsl/" kind="src" path="src/groovy"/>
 	<classpathentry kind="src" path="res"/>
 	<classpathentry exported="true" kind="con" path="GROOVY_DSL_SUPPORT"/>
 	<classpathentry exported="true" kind="lib" path="lib/hsqldb.jar"/>
